---
title: XRHandedness
slug: Web/API/XRHandedness
tags:
  - API
  - AR
  - Enum
  - Enumerated Type
  - Handedness
  - Reference
  - Type
  - VR
  - WebXR
  - WebXR Device API
  - XRHandedness
  - hand
  - left
  - right
---
<p>{{APIRef("WebXR")}}</p>

<p>The WebXR enumerated type <code><strong>XRHandedness</strong></code> provides values which identify which of a user's hands is being used to operate a particular input controller attached to the XR input device being used. <code>XRHandedness</code> is used as the value of the the {{domxref("XRInputSource")}} property {{domxref("XRInputSource.handedness", "handedness")}}.</p>

<h2 id="Values">Values</h2>

<dl>
 <dt><code>none</code></dt>
 <dd>The input controller is not associated with one of the user's hands.</dd>
 <dt><code>left</code></dt>
 <dd>The input controller is being held in, worn on, or is attached to the user's left hand.</dd>
 <dt><code>right</code></dt>
 <dd>The input controller is being held in, worn on, or is attached to the user's right hand.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>One important usage scentario for <code>handedness</code> is to determine which hand a controller is in so you can draw a representation of that hand (or the device that hand is controlling) in virtual space.</p>

<pre class="brush: js notranslate">function updateInputSources(session, frame, refSpace) {
  for (let source of session.inputSources) {
    if (source.gripSpace) {
      let gripPose = frame.getPose(source.gripSpace, refSpace);

      if (gripPose) {
        myRenderHandObject(gripPose, inputSource.handedness);
      }
    }
  }
}
</pre>

<p>This function, which would be called every animation frame (or possibly just periodically, depending on the degree of smoothness required and any performance constraints), scans the list of input sources looking for any which have a {{domxref("XRInputSource.gripSpace", "gripSpace")}} which isn't <code>null</code>. If a <code>gripSpace</code> is present, that means the input source is a hand-held device of some sort, so it should be rendered visibly if possible.</p>

<p>If <code>gripSpace</code> is non-<code>null</code>, the function proceeds to get the pose for the <code>gripSpace</code> transformed into the current reference space. Assuming that's then valid, a function called <code>myRenderHandObject()</code> is called with the grip's pose and the value of <code>handedness</code>. With these values in hand (no pun intended), <code>myRenderHandObject()</code> can draw the appropriate model positioned and formed for the correct hand.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#enumdef-xrhandedness','XRHandedness')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.XRHandedness")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs">Inputs and input sources</a></li>
 <li><a href="/en-US/docs/Web/WebXR%20Device%20API/Gamepads">Using gamepads in WebXR applications</a></li>
 <li>{{domxref("XREye")}}: Indicates which eye a view should be displayed for</li>
</ul>
